<?php
/**
 * @file
 * Contains the SunMailerContentEventHandler class.
 */

class SunMailerContentEventHandler implements ISunMailerContentEventHandler {
  public function sectionAddForm() {
    $form = array();
    $form['subscribe'] = array(
      '#type' => 'radios',
      '#title' => 'Subscriptions',
      '#options' => array(
        'any' => 'Add any subscriber',
        'all' => 'Add only subscribers who are subscribed to all of this newsletter\'s sections',
        'none' => 'Add no subscribers',
      ),
      '#default_value' => 'any',
    );
    return $form;
  }

  public function sectionAddValidate(&$edit) {
    return NULL;
  }

  public function sectionAddSubmit($section, &$edit) {
    switch ($edit['subscribe']) {
    case 'any':
      $query = "INSERT INTO {sunmailer_subscriptions} (SELECT DISTINCT(sms.smid), %d FROM {sunmailer_subscriptions} sms, {sunmailer_sections} s WHERE sms.sid = s.sid AND s.nlid = %d)";
      db_query($query, $section->getSectionId(), $section->getNewsletterId());
      break;

    case 'all':
      $query = "SELECT COUNT(*) FROM {sunmailer_sections} WHERE nlid = %d";
      $count = db_result(db_query($query, $section->getNewsletterId())) - 1;
      $query = "INSERT INTO {sunmailer_subscriptions} (SELECT sms.smid, %d FROM {sunmailer_subscriptions} sms, {sunmailer_sections} s WHERE sms.sid = s.sid AND s.nlid = %d GROUP BY sms.smid HAVING COUNT(sms.sid) = %d)";
      db_query($query, $section->getSectionId(), $section->getNewsletterId(), $count);
      break;

    case 'none':
      break;
    }
  }

  public function sectionDelete($section) {
    $query = "DELETE FROM {sunmailer_subscriptions} WHERE sid = %d";
    db_query($query, $section->getSectionId());
  }

  public function newsletterDelete($newsletter) {
    $query = "DELETE FROM {sunmailer_subscriptions} WHERE sid IN (SELECT sid FROM {sunmailer_sections} WHERE nlid = %d)";
    db_query($query, $newsletter->getNewsletterId());
  }
}