<?php
/**
 * @file
 * Contains the SunMailerSubscriptionAggregator class.
 */

class SunMailerSubscriptionAggregator implements ISunMailerSubscriptionAggregator {
  public function getNewsletterSubscriptions($nlid) {
    $query = "SELECT sm.mail, su.sid FROM {sunmailer_subscribers} sm, {sunmailer_subscriptions} su, {sunmailer_sections} se WHERE sm.smid = su.smid AND su.sid = se.sid AND se.nlid = %d ORDER BY sm.smid, su.sid";
    $result = db_query($query, $nlid);
    $subscriptions = array();
    while ($row = db_fetch_object($result)) {
      $subscriptions[$row->mail][] = $row->sid;
    }
    return $subscriptions;
  }

  public function getGroupedNewsletterSubscriptions($nlid) {
    $subscriptions = $this->getNewsletterSubscriptions($nlid);
    $groupedSubscriptions = array();
    foreach ($subscriptions as $mail => $sids) {
      $groupedSubscriptions[implode(',', $sids)][] = $mail;
    }
    return $groupedSubscriptions;
  }

  public function getAllSubscribers($nlids = array()) {
    if (count($nlids)) {
      // Select subscribers for the specific newsletters.
      $placeholders = db_placeholders($nlids);
      $query = "SELECT DISTINCT(sm.mail) AS mail FROM {sunmailer_subscribers} sm, {sunmailer_subscriptions} su, {sunmailer_sections} se WHERE sm.smid = su.smid AND su.sid = se.sid AND se.nlid IN ($placeholders)";
      $result = db_query($query, $nlids);
    }
    else {
      // Select all subscribers.
      $query = "SELECT mail FROM {sunmailer_subscribers}";
      $result = db_query($query);
    }
    $subscribers = array();
    while ($mail = db_result($result)) {
      $subscribers[] = $mail;
    }
    return $subscribers;
  }
}